
#include"nrf24l01.h"

u8  TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0xe7};	
u8  RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0xe7};	

unsigned char sta;

/*******************************************************************************
u8 char SPI_ReadByte(void)

*******************************************************************************/
u8 SPI_ReadByte(void)
{
  return SPI_ReadWrite(Dummy_Byte);
}
/****************************************************************************
u8	SPI_ReadWrite(unsigned char writedat)

****************************************************************************/ 
u8 SPI_ReadWrite(u8 writedat)
{
	/* Loop while DR register in not emplty */
	while(SPI_I2S_GetFlagStatus(SPI2,SPI_I2S_FLAG_TXE) == RESET);
	
	/* Send byte through the SPI2 peripheral */
	SPI_I2S_SendData(SPI2, writedat);
	
	/* Wait to receive a byte */
	while(SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET);
	
	/* Return the byte read from the SPI bus */
	return SPI_I2S_ReceiveData(SPI2);
}
/****************************************************************************
*u8 SPI_Write_Reg(u8 Addr,u8 Value)
 
****************************************************************************/ 
u8 SPI_Write_Reg(u8 Addr,u8 Value)
{
    u8 status;
	NRF24L01_CSN_LOW();	//CS enable 
    status = SPI_ReadWrite(Addr);
	SPI_ReadWrite(Value);	
    NRF24L01_CSN_HIGH();//CS disable
	return status;
}
/****************************************************************************
u8 SPI_Write_Buf(u8 Addr,u8 *Buffer,u8 Count)

****************************************************************************/ 
u8 SPI_Write_Buf(u8 Addr,u8 *Buffer,u8 Count)
{
	u8 i=0;
	u8 status;
	NRF24L01_CSN_LOW();	//CS enable 
	status = SPI_ReadWrite(Addr);
	for(i=0;i<Count;i++)
	{
	 SPI_ReadWrite(Buffer[i]);
	}
	NRF24L01_CSN_HIGH();//CS disable
	return status;	
}
/****************************************************************************
u8 SPI_Read_Reg(u8 Addr)

****************************************************************************/ 
u8 SPI_Read_Reg(u8 Addr)
{
	unsigned char Data=0;
	NRF24L01_CSN_LOW();	//CS enable	  
	SPI_ReadWrite(Addr|RF_READ_REG);
	Data = SPI_ReadWrite(0);
	NRF24L01_CSN_HIGH(); //CS disable
	return Data;
}
/****************************************************************************
u8 SPI_Read_Buf(u8 Addr,u8 *Buffer,u8 Count)

****************************************************************************/ 
u8 SPI_Read_Buf(u8 Addr,u8 *Buffer,u8 Count)
{
	u8 i=0 ;
	u8 status;
	NRF24L01_CSN_LOW();	//CS enable

	status = SPI_ReadWrite(Addr|RF_READ_REG);
	for(i=0;i<Count;i++)
	{
		Buffer[i]=SPI_ReadWrite(0);//read data		
	}
	NRF24L01_CSN_HIGH(); //CS disable
	return status;
}
/****************************************************************************
void SetRX_Mode(void)

****************************************************************************/ 
void SetRX_Mode(void)
{
	NRF24L01_CE_LOW();
	SPI_Write_Reg(RF_WRITE_REG + CONFIG, 0x0b);
	NRF24L01_CE_HIGH();
    //Delay(10);		     //delay 1ms
}
/****************************************************************************
u8 nRF24L01_RxPacket(unsigned char * rx_buf)

****************************************************************************/
u8 nRF24L01_RxPacket(unsigned char * rx_buf)
{
    u8 revale=0;
	sta=SPI_Read_Reg(STATUS);	 // ȡ״̬Ĵжݽ״	
	if(sta&0x40)                 // жǷյ
	{
	    NRF24L01_CE_LOW(); 			//nrf24 ceʹ
	    SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
	   
        revale =1;			//ȡɱ־
	}
	SPI_Write_Reg(RF_WRITE_REG+STATUS,sta);    //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
    SPI_Read_Buf(FLUSH_RX,&sta,0);
	return revale;
}
/****************************************************************************
void nRF24L01_TxPacket(u8 * tx_buf)

****************************************************************************/
void nRF24L01_TxPacket(u8 * tx_buf)
{
	NRF24L01_CE_LOW(); 					//StandBy Iģʽ	
	SPI_Write_Buf(RF_WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ	
    SPI_Write_Reg(RF_WRITE_REG + CONFIG, 0x0a);   		 // IRQշжӦ16λCRC
	NRF24L01_CE_HIGH(); 		 //øCEݷ
	delay(10);           // С300us 
}
/****************************************************************************
void NRF24L01_Init(void)

****************************************************************************/
void NRF24L01_Init(void)
{	

    NRF24L01_SCK_LOW();
	NRF24L01_MOSI_LOW();
	NRF24L01_CE_LOW();
	NRF24L01_CSN_HIGH();	    //DISABLE CS
	delay(1);
    SPI_Write_Reg(RF_WRITE_REG + CONFIG,0x00);
    SPI_Write_Reg(RF_WRITE_REG + EN_AA, 0x00);        //  disable Ƶ0Զ	ACKӦ	
    SPI_Write_Reg(RF_WRITE_REG + EN_RXADDR, 0x01);    //  disableյַֻƵ0ҪƵԲοPage21
    SPI_Write_Reg(RF_WRITE_REG + SETUP_AW,0x03);      //շַ5ֽ
    SPI_Write_Reg(RF_WRITE_REG + RF_CH, 81);        //   ŵΪ2.481GHZշһ
    SPI_Write_Reg(RF_WRITE_REG + SETUP_RETR,0x1a);  //Զط
    SPI_Write_Reg(RF_WRITE_REG + RF_SETUP, 0x0f);     //÷Ϊ2MHZ书Ϊֵ0dB
    SPI_Write_Reg(RF_WRITE_REG + STATUS,0x70);        // reset status register
    SPI_Write_Buf(RF_WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	SPI_Write_Buf(RF_WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Reg(RF_WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ16ֽ
	delay(10);	
}
/****************************************************************************
u8 nRF_ready(void)

****************************************************************************/
u8 nRF_ready(void)
{
  unsigned char channel=81;
  SPI_Write_Buf(5,&channel,1);
  channel=12;
  SPI_Read_Buf(5,&channel,1);
  return channel==81;
}
/****************************************************************************
void  Detect_nrf24l01(void)

****************************************************************************/
void  Detect_nrf24l01(void)
{
    do{
       // LED1_Light;
        NRF24L01_Init();       // PTX Mode
      }while(!nRF_ready());
     // LED_Flash(50,10);		   //LED1 100ms˸5
}


void  init_port_nrf24(void)
{
	
  GPIO_InitTypeDef GPIO_InitStructure; 

	SPI_InitTypeDef SPI_InitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);
	RCC_APB2PeriphClockCmd( RCC_APB2Periph_AFIO,ENABLE);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

//	 PB0-IRQ  INPUT
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
//   PC5-CE  OUTPUT
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	//CS-PC4
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    //GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;			  
	GPIO_Init(GPIOB, &GPIO_InitStructure);
		
	SPI_Cmd(SPI2,DISABLE);

	SPI_InitStructure.SPI_Direction=SPI_Direction_2Lines_FullDuplex;//SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode=SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize=SPI_DataSize_8b;
	SPI_InitStructure.SPI_CPOL=SPI_CPOL_Low;
	SPI_InitStructure.SPI_CPHA=SPI_CPHA_1Edge;
	SPI_InitStructure.SPI_NSS=SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler=SPI_BaudRatePrescaler_8;
	SPI_InitStructure.SPI_FirstBit=SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial=7;

	SPI_Init(SPI2,&SPI_InitStructure);
	SPI_Cmd(SPI2,ENABLE);


  
	NRF24L01_CSN_LOW() 	            // disable NRF24 cs	
  	
}

